/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 ********************************************************************/
#ifndef synaps_arithm_Field_h
#define synaps_arithm_Field_h
//===================================================================
#include <string>
#include <synaps/arithm/Ring.h>
#include <synaps/arithm/traits.h>
//===================================================================
__BEGIN_NAMESPACE_SYNAPS
//===================================================================

template<class X> struct Field : Ring<X>
{
  typedef X T;
  Field(){}
  Field(const Field<X>& t) {}
  Field(const X& x) {}
  inline std::string str() { return "Field"; }
};


template<class C> inline Field<typename arithm::fieldof<C,C>::T> make_field(const C& c) 
{ return Field<typename arithm::fieldof<C,C>::T>(); }

template<class C> 
inline Field<typename arithm::fieldof<C,C>::T> field_of(const Ring<C>& rg) 
{ return Field<typename arithm::fieldof<C,C>::T>(); }

//===================================================================
__END_NAMESPACE_SYNAPS
#endif //
