#ifndef SYNAPS_ARITHM_TRAITS_ISRATIONAL_H
#define SYNAPS_ARITHM_TRAITS_ISRATIONAL_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X> struct isrational_  { typedef false_t T; };

  template<class K, class X>
  struct kernel_isrational  { typedef false_t T; };

  template<class K>
  struct kernel_isrational< K, typename K::rational >  { typedef true_t T; };
  
  template<class X>
  struct kernel_isrational< null_t, X > { typedef typename isrational_<X>::T T; };
  
  template<class X> struct isrational 
  {
    typedef typename ucstref<X>::T _X;
    typedef typename kernel_isrational< typename kernelof<X>::T, _X >::T T;
  };

}

__END_NAMESPACE_SYNAPS

#endif
