#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/arithm/Zp.h>
#include <synaps/upol.h>
#include "synaps/arithm/gmp.h"
#include <synaps/upol/bezier/rep1d.h>

typedef UPolDse<double, bezier::rep1d<double> > upolb_t;



int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;

  upolb_t b1("x^2+1"), b2("x"), b3;
  VECTOR::print(cout,b1)<<endl;
  VECTOR::print(cout,b2)<<endl;
  b3 = b1*b2;
  cout <<b3<<endl;
  VECTOR::print(cout,b3)<<endl;

} 
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP

