#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include "synaps/arithm/gmp.h"
#include "synaps/mpol.h"
#include "synaps/mpol/MPolDse.h"

typedef MPolDse<QQ> mpold_t;
typedef MPolDse<QQ, mpoldse::bernstein<QQ> > mpolb_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;

  mpolb_t A("x1^2*x0+2*x1+3"),B("x0+x1+1"),C=A*B; 
  VECTOR::print(cout,A.rep())<<endl;
  VECTOR::print(cout,B.rep())<<endl;
  VECTOR::print(cout,C.rep())<<endl;
  std::cout<<C<<std::endl;

} 

#else
int main(int argc, char** argv) {}
#endif
