#include <synaps/init.h>
#ifdef SYNAPS_WITH_LAPACK
#include <synaps/arithm/QQ.h>
#include <synaps/upol/UPolDse.h>

UPolDse<QQ> Wilkinson(unsigned n)
{
  UPolDse<QQ> p("1"), l("x-1");
  for(unsigned i=0;i<n;i++) {p*=l;l-=QQ(1);}
  return p;
}
int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;

  cout<<Wilkinson(5)<<endl;
  cout<<Wilkinson(20)<<endl;

}
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
