#ifndef NorM_H
#define NorM_H

#include <synaps/init.h>
#include <synaps/arithm/RealOf.h>


__BEGIN_NAMESPACE_SYNAPS

template<class A>
typename RealOf<typename A::value_type>::TYPE norme2(const A & V)
{
  typedef typename A::size_type size_type;
  typedef typename A::value_type value_type;

  value_type res(0);
  size_type taille(V.size());
  for(size_type i=0; i < taille; i++){
    res = res + V[i]*V[i];
  }
  return(sqrt(res));
}

__END_NAMESPACE_SYNAPS

#endif
