#include <synaps/mpol/Variables.h>

__BEGIN_NAMESPACE_SYNAPS

Variables Variables::default_;

std::string Variables::operator[](int i)// const
{
  if(_var_of_index[i+1]!="")
    return _var_of_index[i+1];
  else
    {
      int sz=1,m=1;
      while(m<i) {m*=10; sz++;}
      char str[sz];
      sprintf(str,"%d",i);
      return std::string("x")+str;
    }
}

std::string Variables::operator[](int i) const
{
  std::map<int,std::string>::const_iterator pt=_var_of_index.find(i+1);
  if(pt!= _var_of_index.end())
    return pt->second;
  else
    {
      int sz=1,m=1;
      while(m<i) {m*=10; sz++;}
      char str[sz];
      sprintf(str,"%d",i);
      return std::string("x")+str;
    }
}

std::string& Variables::let(int i, const std::string& s)
{
  _index_of_var[s]=i+1;
  _var_of_index[i+1]=s;
  if(i+1>_nbvar) _nbvar=i+1;
  return  _var_of_index[i+1];
}

Variables& Variables::operator=(const char* s)
{
  std::string  v;
  _nbvar=0;
  std::istringstream ins(s);
  while(ins.good())
    {
      ins >>v;
      this->let(_nbvar,v);
    }
  return *this;
}

int Variables::operator[](const std::string& s)
{
  //  std::cout  <<">> "<<s<<" "<<_nbvar<<" ";
  if(s[0]=='x' && s.size()>1 )
    {
      const char* var=s.data()+1;
      //   _nbvar= std::max((int)_nbvar,atoi(var)+1);
      //   std::cout<<":"<<atoi(var)<<std::endl;
      return atoi(var);
    }
  else
    {
      if(_nbvar==0)
	{
	  _nbvar++;
	  _index_of_var[s]=_nbvar;
 	  _var_of_index[_nbvar]=s;
	  return 0;
	}
      else 
	{
	  int i=_index_of_var[s]-1;
	  if(i<0)
	    {
	      while(_var_of_index[_nbvar]!="")
		{
		  _nbvar++;
		}
	      i=_nbvar-1;
	      //   std::cout<<"I  "<<i<<std::endl;
	      _index_of_var[s]=_nbvar;
	      _var_of_index[_nbvar]=s;
	    }
	  return i;
	}
    }
}
__END_NAMESPACE_SYNAPS
