#include <synaps/mpol/Dual.h>


int main(int argc, char** argv) 
{
  Dual<double> l("x0^2-x1+x1*x2");
  std::cout<<l<<std::endl;

  Dual<double>::poly_t x1("x1"), p("x1^2+2*x1*x2-10");
  std::cout<<p<<std::endl;
  std::cout<<p*l<<std::endl;
  std::cout<<l*p<<std::endl;
  std::cout<<l(p)<<std::endl;
  assert(l(p)==2);
  std::cout<<l(x1*p)<<std::endl; 
  assert(l(x1*p)==(x1*l)(p));
}
