
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename mon>
int my_ord(const mon & m1, const mon & m2){
   int n1 = lvar(m1.rep()), n2 =lvar(m2.rep());
   int n = std::max(n1,n2),dm1=0,dm2=0,firstdiff=0,tmpdeg1,tmpdeg2;
	
   if(n1 <0 && n2>0) return -1;
   if(n2 <0 && n1>0) return 1;
   for(int i=0;i<=n;i++)
     {
       tmpdeg1=m1[i];
       tmpdeg2=m2[i];
       if(tmpdeg1>tmpdeg2 && firstdiff==0) firstdiff=1;
       if(tmpdeg2>tmpdeg1 && firstdiff==0) firstdiff=-1;
       dm1+=tmpdeg1;
       dm2+=tmpdeg2;
     }
   //dm1=Degree(m1);
   //dm2=Degree(m2);
   if (dm1 < dm2) return -1;
   else if (dm1 > dm2) return 1;
   return firstdiff;
   
   //else {
   //  int i=n;
   //  while( m1.GetDegree(i) == m2.GetDegree(i) && i>=0) i--;
   //  if(i <0) 
   //    return 0;
   //  else 
   //  return ((m1.GetDegree(i)> m2.GetDegree(i)?1:-1));
   //}
}



__END_NAMESPACE_SYNAPS


