
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


//Requiers type mon to be defined somewhere else
//on tache de rendre l'acces a int2mon et mon2int 
//aussi rapide que possible meme si ca coute 
//un peu, d'inserer puisque par hypothese on fait plus 
//d'appel a int2mon mon2int 
//que l'on insere ou enleve de monomes dedans!
template<typename mon>
struct serveur{
  int size;
  mon *int2mon_;
  mon *mon2intmon;
  int *mon2intint;
  int (*ord)(const mon &m1,const mon &m2);
  ~serveur() {
    MAC_REV_FREE<mon>(int2mon_,size*sizeof(mon));
    MAC_REV_FREE<mon>(mon2intmon,size*sizeof(mon));
    MAC_REV_FREE<int>(mon2intint,size*sizeof(int));
  }
  serveur() {
    size=0;int2mon_=NULL;mon2intmon=NULL;mon2intint=NULL;
    ord=NULL;
    }
template<typename ptrfun>
void setorder(ptrfun tmpord)
{
  ord=(int (*)(const mon &,const mon &))(tmpord);
}
int sizeplacemon()
{
  return size;
}
//template<typename mon>
void putmon2(const mon & m,const int poscurrent)
{
  int i;
  //si le monome est deja introduit on y touche pas
  //cout<<"putmon2 atteint"<<endl;
  //cout<<"poscurrent "<<poscurrent<<endl;
  //cout<<"mon2intmon==NULL?? "<<(mon2intmon==NULL)<<" m "<<m<<endl;
  //if (poscurrent<size)
  //  cout<<((mon2intmon==NULL)||(mon2intmon[poscurrent]==m))<<endl;
  if((mon2intmon==NULL)||(poscurrent==size)||
     (mon2intmon[poscurrent].rep()!=m.rep()))
    {
      //  cout<<"moncurent etc passe etc vaut "<<endl;
      size++;
      mon2intmon=(mon*)MAC_REV_REALLOC<mon>(mon2intmon,(size-1)*sizeof(mon)
					    ,(size)*sizeof(mon));
      mon2intint=(int*)realloc(mon2intint,size*sizeof(int));
      //int2mon=(mon*)realloc(int2mon,size*sizeof(mon));
      //on vient d'agrandir les tableaux
      for(int k=size-1;k>poscurrent;k--)
	mon2intmon[k]=mon2intmon[k-1];
      //memmove((mon2intmon+poscurrent+1),(mon2intmon+poscurrent),
      //	      (size-1-poscurrent)*sizeof(mon));
      memmove((mon2intint+poscurrent+1),(mon2intint+poscurrent),
	      (size-1-poscurrent)*sizeof(int));
      //on cherche s'il y a un indice dans int2mon libre
      for(i=0;i<size-1;i++)
	if (int2mon_[i]==mon(-1)) break;
      if (i==size-1)
	{
	  int2mon_=(mon*)MAC_REV_REALLOC<mon>(int2mon_,(size-1)*sizeof(mon)
					 ,size*sizeof(mon));
	}
      int2mon_[i]=m;
      //cout<<"int2mon_["<<i<<"] vaut "<<m<<endl;
      mon2intint[poscurrent]=i;
      mon2intmon[poscurrent]=m;
      //cout<<"mon2intmon["<<poscurrent<<"] vaut"<<mon2intmon[poscurrent]
      //	  <<" et est sense valoir "<<m<<endl;
    }
  return;
}

//template<typename mon>
void putmon(const mon & m)
{
  int inf=0,sup=size,poscurrent=0;
  //on commence par localiser l'endroit dans mon2int*
  //ou on va rajouter le monom
  if(size!=0)
    for(poscurrent=size/2;ord(mon2intmon[poscurrent+1],
			      m)&&
	  ord(m,mon2intmon[poscurrent-1]);)
      {
	if(ord(mon2intmon[poscurrent],m)>0)
	  {
	    sup=poscurrent;
	    poscurrent=(inf+sup)/2;
	  }
	else
	  {
	    inf=poscurrent;
	    poscurrent=(inf+sup)/2;
	  }
      }
  putmon2(m,poscurrent);
  return ;
}


//template<typename mon>
void removemon(const mon &m)
{
  int inf=0,sup,poscurrent,i;
  //on commence par localiser l'endroit dans mon2int*
  //ou on va rajouter le monom
  for(poscurrent=size/2;ord(mon2intmon[poscurrent+1],
				m)&&
	ord(m,
	    mon2intmon[poscurrent-1]);)
    {
      if(ord(mon2intmon[poscurrent],m)>0)
	{
	  sup=poscurrent;
	  poscurrent=(inf+sup)/2;
	}
      else
	{
	  inf=poscurrent;
	  poscurrent=(inf+sup)/2;
	}
    }
  //si le monome n'est PAS deja introduit on  touche a rien
  if(mon2intmon[poscurrent]!=m)
    {
      //on libere l'endroit ou se trouve ce monome
      int2mon_[poscurrent]=mon(-1);
      //on recopier apres dans les mon2int pour enlever le monome
      memmove((mon2intmon+poscurrent),(mon2intmon+poscurrent+1),
	      (size-poscurrent-2)*sizeof(mon));
      memmove((mon2intint+poscurrent),(mon2intint+poscurrent+1),
	      (size-poscurrent-2)*sizeof(int));
      //on retrecit les mon2int*
       size--;
       mon2intmon=(mon*)realloc(mon2intmon,size*sizeof(mon));
       mon2intint=(int*)realloc(mon2intint,size*sizeof(int));
    }
  return;
}


//template<typename mon>
void affplace(const mon &m,int p)
{
  int2mon_[p]=m;
}
//template<typename mon>
void freeplace(int p)
{
  int2mon_[p]=mon(-1);
}
//template<typename mon>
void int2mon(const int &i,mon &res) const
{
  res=*(int2mon_+i);
}

//template<typename mon>
int mon2int(const mon &mm)
{
  typedef typename mon::coeff_t coeff;
  //mon2intmon et mon2intint doivent etre trie 
  //par aordre (ord) croissant
  //
  int inf=0,sup=size,poscurrent;
  mon m=mm;
  m.setcoeff(1);
  // cout<<"rentre mon2int"<<endl;
  //cout<<"size "<<size<<endl;
  if(size==0) {mon2intmon=NULL;mon2intint=NULL;
  int2mon_=NULL;putmon(m);
  //cout<<"transition mon2int"<<endl;
  };
  //cout<<"sup "<<sup<<" inf "<<inf<<endl;
  for(poscurrent=size/2;(sup-inf>1)&&
	(mon2intmon[poscurrent].rep()!=m.rep());)
    {
      //  cout<<"poscurrent "<<poscurrent<<endl;
      if(ord(mon2intmon[poscurrent],m)>0)
	{
	  sup=poscurrent;
	  poscurrent=(inf+sup)/2;
	}
      else
	{
	  inf=poscurrent;
	  poscurrent=(inf+sup)/2;
	}
    }
  //cout<<"sortie for mon2int "<<poscurrent<<endl;
  //cout<<"les monome "<<mon2intmon[poscurrent]<<" "<<m<<endl;
  if (mon2intmon[poscurrent].rep()!=m.rep()) 
    {
      if (ord(mon2intmon[poscurrent],m)<0) poscurrent++;
      //if(poscurrent<size)
	//cout<<"ord(mon2intmon[poscurrent],m) "
	//  <<ord(mon2intmon[poscurrent],m)<<endl;
      //cout<<"appel putmon2 "<<endl;
      putmon2(m,poscurrent);
    }
  //cout<<"sorti mon2int"<<endl;
  return mon2intint[poscurrent];
}

template<typename typPk, typename typdump>
void swap_all(int i, int j, typPk & Pk ,typdump& dump)
{
  typedef typename typPk::value_type::monom_t mon;
  typedef typename typdump::value_type dumpstruct;
  mon tmpmon;
  int deg,pos1,pos2;
  int2mon(j,tmpmon);
  deg=degree(tmpmon);
  //  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
  //  cout<<"swap "<<invconv<Poly>(*iter)<<endl;
  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    if(j<iter->size&&!Iszero(iter->nf[j]))
      {
	//cout<<"swapall "<<i<<" "<<j<<" iter->nf[j] "<<iter->nf[j]<<endl;
	iter->nf[i]=iter->nf[j];
	iter->nf[j]=0;
      }
  for(typename typdump::iterator iter=dump.begin();iter!=dump.end();iter++)
    {
      //if(iter->k<=deg)
	{
	  for(typename dumpstruct::pol_t *iterdump=iter->nf;
	      iterdump!=iter->nf+iter->size;iterdump++)
	    {
	      if(j<iterdump->size&&!Iszero(iterdump->nf[j]))
		{
		  iterdump->nf[i]=iterdump->nf[j];
		  iterdump->nf[j]=0;
		}
	    }
	}
    }
  tmpmon=int2mon_[i];
  int2mon_[i]=int2mon_[j];
  int2mon_[j]=tmpmon;
  for(pos1=0;mon2intint[pos1]!=j;pos1++);
  for(pos2=0;mon2intint[pos2]!=i;pos2++);
  mon2intint[pos1]=i;
  mon2intint[pos2]=j;
}

void freeint2mon(int k)
{
  //memmove(int2mon_+k,int2mon_+j+1,(size-j-1)*sizeof(mon));
  int2mon_=(mon*)MAC_REV_REALLOC<mon>(int2mon_,size*sizeof(mon)
				      ,(k)*sizeof(mon));
}
void freemon(int j)
{
  int k;
  //memmove(int2mon_+j,int2mon_+j+1,(size-j-1)*sizeof(mon));
  //int2mon_=(mon*)MAC_REV_REALLOC<mon>(int2mon_,size*sizeof(mon)
  //			      ,(size-1)*sizeof(mon));
  for(k=0;mon2intint[k]!=j;k++);
  //cout<<"k "<<k<<" et size "<<size<<endl;
  memmove(mon2intint+k,mon2intint+k+1,(size-k-1)*sizeof(int));
  for(int i=k;i<size-1;i++)
    mon2intmon[i]=mon2intmon[i+1];
  mon2intmon[size-1]=mon(0);
  //memmove(mon2intmon+k,mon2intmon+k+1,(size-k-1)*sizeof(mon));
  mon2intint=(int*)MAC_REV_REALLOC<int>(mon2intint,size*sizeof(int)
				   ,(size-1)*sizeof(int));
  mon2intmon=(mon*)MAC_REV_REALLOC<mon>(mon2intmon,size*sizeof(mon)
					,(size-1)*sizeof(mon));
  size--;
}  

void serveurcompress(int i)
{
  int tmpsize=size;
  freeint2mon(i+2);
  for(int k=i+2;k<tmpsize;k++)
    freemon(k);
  //for(int j=0;j<size;j++)
  //  cout<<j<<" les pos possibles "<<mon2intint[j]<<" "<<mon2intmon[j]<<" int2mon "<<int2mon_[mon2intint[j]]<<endl;
  // size=i+2;
}

template<typename typPk, typename typdump>
void Docompress(int i, typPk & Pk, typdump& dump)
{
  typedef typename typPk::value_type::monom_t mon;
  typedef typename typPk::value_type::coeff_t coeff;
  typedef typename typdump::value_type dumpstruct;
  
  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    if(i<iter->size)
      {
	int k;
	for(k=i;k>=0&&Iszero(iter->nf[k]);k--);
//		cout<<" do compress K "<<k<<" "<<iter->nf[k]<<endl;
	iter->nf=(coeff*)MAC_REV_REALLOC<coeff>(iter->nf
						,iter->size*sizeof(coeff)
						,(k+1)*sizeof(coeff));
//	cout<<"I "<<i<<" k "<<k<<" et iter->size "<<iter->size<<endl;
	iter->size=k+1;
      }
  
  for(typename typdump::iterator iter=dump.begin();
      iter!=dump.end();iter++)
    //if(iter!=dump.rend())  
    {
      for(typename dumpstruct::pol_t *iterdump=iter->nf;
	  iterdump!=iter->nf+iter->size;iterdump++)
	if(i<iterdump->size)
	{
	  int k;
	  for(k=i;k>=0&&Iszero(iterdump->nf[k]);k--);
	  iterdump->nf=(coeff*)MAC_REV_REALLOC<coeff>(iterdump->nf
					      ,iterdump->size*sizeof(coeff)
					      ,(k+1)*sizeof(coeff));
	  iterdump->size=k+1;
	}
    }
}

template<typename typdump, typename Base, typename typPk>
void compress(typPk & Pk, typdump & dump, const Base  &b, int k)
{
  //return;
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  mon tmpmon;
  int i=0;int j=sizeplacemon()-1;
  //cout<<"Docompress"<<endl;
  for(i=0;i<j;i++)
    {
      int2mon(i,tmpmon);
      if(!IsinB(tmpmon,b))
	//On peut le virer
	{
//	  cout<<"j'ai trouve que je pouvais virer "<<tmpmon<<endl<<" il est en position "<<i<<endl;
	   for(;j>i;j--)
	    {
	      int2mon(j,tmpmon);
	      if(IsinB(tmpmon,b))
		break;
	    }
	  if(i==j) break; //c fini on a plus rien a faire ici
	  //	  cout<<" swap "<<i<<" "<<int2mon_[i]<<" et "<<j<<" "<<int2mon_[j]<<endl;
	  swap_all(i,j,Pk,dump);
	}

    }
  int2mon(i,tmpmon);
  for(;!IsinB(tmpmon,b);i--) 
    {
      int2mon(i,tmpmon);
      //cout<<"tmp mon "<<tmpmon<<endl;
    }
  Docompress(i+1,Pk,dump);
  serveurcompress(i);
}

};//end of serveur


__END_NAMESPACE_SYNAPS

