/********************************************************************
 *   This file is part of the source code of the SYNAPS library.
 *   Author(s): J.P. Pavone, GALAAD, INRIA
 *   $Id: parametric.h,v 1.1 2005/07/11 10:03:56 jppavone Exp $
 ********************************************************************/
#ifndef SYNAPS_SOLVE_SBDSLV_SBDRULES_HPP
#define SYNAPS_SOLVE_SBDSLV_SBDRULES_HPP
//--------------------------------------------------------------------
#include <synaps/init.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
namespace sbdslv 
{
  namespace sbdrl
  {
    template< class solver >
    struct parametric
    {
      inline static bool process( solver * slv ) { 
	/* sans commentaires ! */
	return slv->subdivide(slv->largest(), 0.5 );
      };
    };
  };
};
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
