/********************************************************************
 *   This file is part of the source code of the SYNAPS library.
 *   Author(s): J.P. Pavone, GALAAD, INRIA
 *   $Id: empty.h,v 1.1 2005/07/11 10:03:57 jppavone Exp $
 ********************************************************************/
#ifndef SYNAPS_SOLVE_SBDSLV_STRGY_EMPTY_HPP
#define SYNAPS_SOLVE_SBDSLV_STRGY_EMPTY_HPP
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
namespace sbdslv 
{
  namespace strgy
  {
    /* strategie vide ne peut être utilisée par le solveur, 
       représente la fin de l'accumulation des strategies */
    template< class solver > 
    struct empty
    { bool process( solver * sys ) { return true; }; };
  };
};
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
