#ifndef SYNAPS_SHAPE_FRATIONALSURFACE_H
#define SYNAPS_SHAPE_FRATIONALSURFACE_H

#include <synaps/shape/interfaces/IRationalSurface.h>
#include <synaps/shape/functions/FRationalCurve.h>

__BEGIN_NAMESPACE_SYNAPS
template<class R> inline
void setEquations( R& r, const char * w, const char * x, const char * y, const char * z, const char * variables  )
{
  setEquations( (typename R::base_t&)r, r, w, x, y, z, variables );
};

__END_NAMESPACE_SYNAPS
#endif
