#ifndef SYNAPS_SHAPE_IBSPLINESURFACE_H
#define SYNAPS_SHAPE_IBSPLINESURFACE_H

#include <synaps/shape/interfaces/IParametricSurface.h>

__BEGIN_NAMESPACE_SYNAPS

struct IBSplineSurface : IParametricSurface
{
  typedef IParametricSurface base_t;
  
  virtual void setDefinition( int nbpu, int nbpv, 
			      int ordu, int ordv, 
			      const double * uknots, 
			      const double * vknots, 
			      const double * controls ) = 0;
  
};
__END_NAMESPACE_SYNAPS

#endif
