#ifndef SYNAPS_ISHAPE_H
#define SYNAPS_ISHAPE_H
#include <synaps/init.h>
#include <synaps/base/type.h>

#include "Interface.h"
#include "IGLGood.h"

__BEGIN_NAMESPACE_SYNAPS

struct IShape
{
  //  IFrame * frame;
  typedef type::null_t base_t;
  int refc;
  IShape() : refc(0){};
  int  addref () { return ++refc; };
  void release() { if ( refc <= 1 ) delete this; };
  virtual const char * repname() const  = 0;
  virtual const char * iname ()  const = 0;
  
  virtual ~IShape() {};
  virtual IGLGood * mesh()  = 0;
  virtual IShape * make() const  = 0;
};
__END_NAMESPACE_SYNAPS


#endif
