#ifndef TREES_BNODE_H
#define TREES_BNODE_H
#include <iostream>
#include <vector>

__BEGIN_NAMESPACE_SYNAPS

struct  binary_node_base
{
  binary_node_base * m_l; 
  binary_node_base * m_r; 
  binary_node_base():m_l(0),m_r(0) {}; 
  template<typename T>
  inline void setsons( T * l, T * r ) { m_l = (binary_node_base*)l; m_r = (binary_node_base*)r; };
  inline bool isleaf() const {  return m_l ==  m_r; };
};
struct fbinary_node_base : binary_node_base { fbinary_node_base * m_f; };

template< typename node > inline node const * const left( node const * const n )   
{ return (node*)((binary_node_base*)n)->m_l; };
template< typename node > inline node *& left( node * n ) 
{ return (node*&)((binary_node_base*)n)->m_l; };
template< typename node > inline node const * const right( node const * const n )  
{ return (node*)((binary_node_base*)n)->m_r; };
template< typename node > inline node *& right( node * n ) 
{ return (node*&)((binary_node_base*)n)->m_r; };
template< typename node > inline node const * const father( node const * const n ) 
{ return (node*)((binary_node_base*)n)->m_l; };
template< typename node > inline node *& father( node * n ) 
{ return (node*)((binary_node_base*)n)->m_l; };
int  depth ( binary_node_base * n );
void leaves( std::vector< binary_node_base* >& lvs, binary_node_base * n );
template< typename node >
void leaves( std::vector< node* >& lvs, node * n )
{ leaves( *(std::vector< binary_node_base*>*)(&lvs), (binary_node_base*)n ); };

__END_NAMESPACE_SYNAPS

#endif
