#ifndef SYNAPS_SHAPE_SSIQTSL_H
#define SYNAPS_SHAPE_SSIQTSL_H
#include <vector>
#include "SSIQTS.h"

__BEGIN_NAMESPACE_SYNAPS

struct SSIQTSL : SSIQTS
{
  typedef SSIQTS::vector3 vector3;
  typedef fxv<double,2> vector2;
  std::vector< vector2 > lpts;
  std::vector< vector2 > rpts;
  std::vector< vector3 > spcs;
  std::vector< double  > errs;
  std::vector< vector3 > spcsorig;
  double errmax;
  void gmvdump();
  void gpdump();
  SSIQTSL(  IParametricSurface * srfa, 
	   IParametricSurface * srfb, int n );
};

__END_NAMESPACE_SYNAPS

#endif


