#include <synaps/shape/interfaces/IParametricCurve.h>
#include <synaps/shape/base/fxv.h>
__BEGIN_NAMESPACE_SYNAPS

gmv::stream& operator<<( gmv::stream& o, const IParametricCurve& pc )
{

  int n = 100;
  double * tmp = new double[3*n+n];
  (&pc)->sample( tmp, tmp+3*n, n );

  o.polyline(tmp,n,0,1);
  delete[] tmp;
  return o;
};  



IGLGood * mesh( const IParametricCurve *  pc )
{
  int n = 100;
  double * tmp = new double[3*n+n];
  pc->sample(tmp, tmp+3*n, n );
  IGLGood * result = new IGLGood(IGLGood::E_LINE,n,2*(n-1),false);
  std::copy(tmp,tmp+3*n,result->vertices);

  int c = 0;
  for ( int i = 0; i < n-1; i ++ )
    {
      result->indexes[c]   = i;
      result->indexes[c+1] = i+1;
      c += 2;
    };
  delete [] tmp;
  return result;
};

__END_NAMESPACE_SYNAPS
