#include <synaps/arithm/gmp.h>
#include <synaps/shape/surfaces/quadric.h>

int main(int argc, char** argv) 
{

  implicit::quadric<ZZ> a("x0^2+10*x0*x1+20*x0*x2+100*x1*x2+2*x1^2+3*x2^2+5*x0-7*x1+5*x2-1");
  implicit::quadric<ZZ> b("x0^2+10*x0*x1+x2^2+2*x1^2+5*x0-7*x1-2");
  std::cout<<a<<std::endl;
  std::cout<<b<<std::endl;
  MatrDse<ZZ> A,B;
  assign(A,a);
  std::cout<<A<<std::endl;
  assign(B,b);
  std::cout<<B<<std::endl;
  std::cout<<"Signature sequence: \n";
  std::cout<<qsic_type(a,b)<<std::endl;
}
 
 
