#define USING_NAMESPACE_SYNAPS 1

#include <synaps/upol/UPolDse.h>
#include <synaps/upol/quotient.h>


using std::cout;
using std::cin;
using std::endl;

typedef UPolDse<double> pol_t;

int main()
{
  quotient::ModUPol<double> modpol(pol_t("x0^3-2*x0^2"));
  upol::horner<double> p,q,r;
  modpol.assign(p,"x0^2-2*x0+1");
  modpol.assign(q,"x0-1");
  modpol.print(cout,p);cout<<endl;
  modpol.print(cout,q);cout<<endl;
  modpol.add(r,p,q);
  modpol.print(cout,r);cout<<endl;
  modpol.mul(r,p,q);
  modpol.print(cout,r);cout<<endl;
}
