import os
import sys

def run(dir, slv,  data, type, L, suffix):
    graphic=True
    update=False;
    clean =False;
    ps=False;

    name= sys.argv[0].split(".")[1].split("/")[1]+suffix;
    print name;
    for opt in sys.argv:
	if opt=='-g':
	   graphic=True
	if opt=='-up':
	   update=True
	if opt=='-c':
	  clean=True
       	if opt=='-ps':
           graphic=False
           ps=True
 
    lnm="_";
    for n in L:
	lnm+=str(n)
    fnm=name+".gp"
    res = open(fnm,'w')
    res.write("set style line 3 lt 3 lw 4 ps 1\n")
    res.write("set title \""+type+suffix+"\"\n")
    res.write("set key top left\n")
    res.write("set xlabel \"Degree\"\n")
    res.write("set ylabel \"Average time (s)\"\n")
    res.write("set autoscale x\n")
    res.write("set autoscale y\n")
    res.write("set pointsize 0.9\n")
    if ps:
        res.write("set terminal postscript\n")
        res.write("set output \""+name+".ps\"\n")
        
    i=0
    for s in slv:
	file=s+"_"+type+lnm+suffix
	if clean or not(os.path.isfile("gp/"+file+".gp")):
	   os.system("echo >gp/"+file+".gp")
	   os.system("echo >run/"+file+".run")
           for n in L:
	       os.system("echo \"<run>\">>run/"+file+".run")
	       cmd=dir+"/"+s+" "+data+"/"+type+"/"+str(n)+suffix
	       print cmd
	       exe=cmd+" 1>.out 2>.err"
	       os.system(exe)
	       os.system("/usr/bin/time -v "+exe+" 1>.run 2>.tmp")
	       time= "cat .tmp | grep \"User time (seconds):\"  | sed -e \"s/	User time (seconds): /"+str(n)+" /g\" >>gp/"+file+".gp"
	       os.system(time)
	       os.system("cat .run >>run/"+file+".run")
	       os.system("cat .tmp >>run/"+file+".run")
	       os.system("echo \"</run>\">>run/"+file+".run")
	   os.system("perl -pi -e \"s/d//g\" gp/"+file+".gp") 
	   os.system("cat gp/"+file+".gp")
        if i==0:
            res.write("plot \'gp/"+file+".gp\' using ($1):($2/10) title \""+str(s)+"\" lw 2 pt 1 with linespoints \\\n")
        else:
            res.write(", \'gp/"+file+".gp\' using ($1):($2/10) title \""+str(s)+"\" lw 2 pt "+str(i+1)+" with linespoints \\\n")
        i=i+1
    if graphic:
        res.write("\n\npause -1 \"OK?\"")
    res.close()
    os.system("gnuplot "+fnm)
