#include <iostream>
#include <synaps/arithm/gmp.h>
#include <synaps/upol.h>
#include <synaps/usolve/SturmMem.h>

int main()
{
  using std::cout;
  using std::cin;
  using std::endl;

  UPolDse<ZZ> P("2*x0^7+3*x0^6+2*x0^5+1*x0^4-1*x0^3-2*x0^2-3*x0+1");
  cout <<"Testing: "<<P<<endl;
  SturmMem<ZZ> mth;
  cout <<solve(P,mth,ZZ(-1),ZZ(1))<<endl;
  cout <<solve(P,mth,ZZ(-10),ZZ(10))<<endl;
}

