#ifndef SYNAPS_NUMERICS_DOUBLE_TRAITS_H
#define SYNAPS_NUMERICS_DOUBLE_TRAITS_H

#include <synaps/init.h>
#include <synaps/base/type.h>
#include <synaps/arithm/gmp.h>
#include <synaps/arithm/rounding.h>
#include <synaps/arithm/Interval.h>
__BEGIN_NAMESPACE_SYNAPS

namespace let 
{
  
  inline
    double
    to_XT(double a)
    { return to_double(a); }
  
  inline double numerator(const double& a) { return a; }
  inline double denominator(const double& a) { return 1.0; }

};

__END_NAMESPACE_SYNAPS


#endif // SYNAPS_NUMERICS_DOUBLE_TRAITS_H


