#ifndef SYNAPS_ARITHM_TRAITS_HASFUNCTION_H
#define SYNAPS_ARITHM_TRAITS_HASFUNCTION_H


__BEGIN_NAMESPACE_SYNAPS

namespace arithm {
  
  simple_trait(hasgcd,false_t);
  simple_trait(hassqrt,false_t);
  simple_trait(hasisqrt,false_t);

  template< typename X >
    struct hasfunction
    {
      typedef typename hasgcd  < typename type::ucstref<X>::T >::T  gcd;
      typedef typename hassqrt < typename type::ucstref<X>::T >::T  sqrt;
      typedef typename hasisqrt< typename type::ucstref<X>::T >::T isqrt;
    }; 
}

__END_NAMESPACE_SYNAPS

#endif

