#ifndef SYNAPS_ARITHM_TRAITS_RATIONALOF_H
#define SYNAPS_ARITHM_TRAITS_RATIONALOF_H
#include <gmpxx.h>
#include <synaps/arithm/traits/integerof.h>
#include <synaps/arithm/Rational.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm
{
  // a cause de bound sur une instantiation de rootof avec tout en double precision
  template<class X> struct rationalof_ { typedef mpq_class T; };
  //			 Rational< typename integerof<X>::T > T;  };
  template<class K, class X>
  struct kernel_rationalof { typedef typename K::rational T; };
  template<class X>
  struct kernel_rationalof<null_t,X> { typedef typename rationalof_<X>::T T; };
  template<class X>
  struct rationalof
  {
    typedef typename ucstref<X>::T _X;
    typedef typename kernel_rationalof< typename kernelof<X>::T, _X  >::T T;
  };
};

__END_NAMESPACE_SYNAPS

#endif
