#ifndef SYNAPS_UTIL_CREATE_ITERATOR_H
#define SYNAPS_UTIL_CREATE_ITERATOR_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

//----------------------------------------------------------------------
template<class C> inline
C* create(C* ptr, C* tab, unsigned int n)
{
  return tab+n;
}
//----------------------------------------------------------------------
template<class C, class T_ptr, class T_stride, class T_ref> class stride_iterator;

template<class C, class T_ptr, class T_stride, class T_ref> inline
stride_iterator<C,T_ptr,T_stride,T_ref>
  create(stride_iterator<C,T_ptr,T_stride,T_ref> it,C* tab, unsigned int n)
{
  return stride_iterator<C,T_ptr,T_stride,T_ref>(tab+n,1);
}
//----------------------------------------------------------------------

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_UTIL_CREATE_ITERATOR_H

