/*********************************************************************
*      This file is part of the source code of SYNAPS software.      *
*      (C) B. Mourrain, GALAAD, INRIA,                               *
**********************************************************************
History:
$Id: parser.h,v 1.1 2005/07/11 11:23:12 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_BASE_PARSER_H
#define SYNAPS_BASE_PARSER_H

#include <synaps/init.h>
#include <synaps/base/parser_def.h>

__BEGIN_NAMESPACE_SYNAPS

extern "C" int yylex(void);
extern "C" char *synaps_input;
extern "C" char *synaps_inputptr; /* current position in myinput */
//char *yytext; /* current position in myinput */
extern "C" char *synaps_inputlim; /* end of data */
extern "C" char *yylval;

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_BASE_PARSER_H
