#include <stdlib.h>
#include "synaps/linalg.h"
#include "synaps/base/Clock.h"

typedef MatrDse<double> mat_t;
//typedef MatrDse<double,lapack::rep2d<double> > Matr;

int main(int argc, char** argv) 
{
  using std::cin;
  using std::cout;
  using std::endl;
  unsigned n;
  if(argc >1) 
    n=atoi(argv[1]);
  else 
    n=20;

  cout<<"Size of the matrices: "<<n<<endl;
  mat_t M(n,n);

  unsigned N=100;

  Clock c;  c.start();
  for(unsigned s=0;s<N;s++)
  {
    for(unsigned i=0;i<M.nbrow();i++)
      for(unsigned j=0;j<M.nbrow();j++)
	M(i,j)=1-(2.0*rand())/RAND_MAX;
    Svd(M);
  }
  c.stop();
  cout << c.time()/N<<endl;
  
}
