#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/arithm/gmp.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/usolve/Aberth.h>

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  UPolDse<QQ> p("x^7-2324325131254354*x-1");
  cout<<p<<endl;
  Seq<RR> sol= solve(p, SlvAberth<RR>());
  cout<<sol<<endl;

  cout<<p(sol[1])<<endl;
}
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
