#ifdef SYNAPS_WITH_GMP
#include "synaps/arithm/ZZ.H"
#include "synaps/mpol.H"

typedef MPol<ZZ>   mpol_t;

int main (int argc, char **argv)
{
  using std::cout;
  using std::endl;
  mpol_t p("x1^2*x0+2*x1+3"), q("x1^2+x2");
  cout<<p<<endl;
  p *= q;
  cout<<p<<endl;
  for(mpol_t::iterator it=p.begin(); it !=p.end(); it++)
    cout<<it->coeff()<<" ";
  cout<<endl;
} 

#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
