#ifndef LAPACK_EXTERN_SYM2D_H
#define LAPACK_EXTERN_SYM2D_H

//----------------------------------------------------------------------

#ifdef HAVE_CONFIG_H
#include <synaps/config.h>
#endif

#include "f2c.h"

#ifndef F77NAME
	#ifdef F77_FUNC
		#define F77NAME(x) F77_FUNC(x,x)
	#else
		#define F77NAME(x) x##_
	#endif
#endif

//----------------------------------------------------------------------
extern "C" 
{
  void F77NAME(dsytrf)(char * UPLO, 
		       integer *N, doublereal *A, integer *LDA,
		       integer *IPVT, doublereal *WORK, integer *LWORK,
		       integer *INFO); 
  void F77NAME(dstev)(char * JOBZ, 
		       integer *N, doublereal *D, doublereal *E, doublereal *Z,
		       integer *LDZ, doublereal *WORK, integer *INFO);
  void F77NAME(dsyevd) (char *JOBZ, char *UPLO, integer *N, 
		       doublereal *A, integer *lda,
		       doublereal *W, doublereal *WORK, integer *LWORK,  
		       integer *IWORK, integer* LIWORK, integer *INFO);

}
//----------------------------------------------------------------------

#endif // LAPACK_EXTERN_SYM2D_H

