

#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename typMk>
int indice(const typename typMk::value_type & m, const typMk &stockmon)
{
  int res=0;
  for(typename typMk::const_iterator iter=stockmon.begin();
      (iter->rep()!=m.rep())&&(iter!=stockmon.end());iter++,res++);
  return res;
}

//on suppose stockmon vide
template<typename Base, typename typstock, typename typdump>
void computestockmon(typstock &stockmon, const Base &b, const typdump &dump)
{
  using namespace std;
  typedef typename typstock::value_type mon;
  int maxdeg=0;
  //int taillequo=0,tmp=0;
  //  mon *who=NULL;
  list<mon> current;
   current.push_back(mon(1));
  stockmon.push_back(mon(1));
  {
    typename typdump::const_iterator iter;
      for(iter=dump.begin();
	  iter!=dump.end();iter++);
    maxdeg=(--iter)->k;
  }
  //on a le degre max
  //le quotient est connexe a 1 donc on part 
  //de 1 et on decrit le reste en multipliant par les variables
  for(int i=0;i<maxdeg;i++)
    {
      list<mon> tmpcurrent=current;
      //my_merge(stockmon,current);
      current.erase(current.begin(),current.end());
      for(int i=0;i<b.nbvar();i++)
	{
	  for(typename list<mon>::iterator iter=tmpcurrent.begin();
	      iter!=tmpcurrent.end();iter++)
	    current.push_back((*iter)*mon(i,1));
	}
      //maintenant on tri;
      for(typename list<mon>::iterator iter=current.begin();iter!=current.end();iter++)
	if((IsinB(*iter,b))&&(!member(stockmon,*iter)))
	  {
	    stockmon.push_back(*iter);
	  }
      else
	{
	  current.erase(iter--);
	}
    }
  return;
} 


//on suppose dqans un premier temps que le pol qui est donne
//en parametre est en fait une variable 
template<typename typmat,typename typdump,typename Base, 
	 typename typstock, typename typserv>
void matmul(typmat & m,const int p,const typdump &dump,const Base &b, const typstock &stockmon, const typserv &serv)
{
  using namespace std;
  typedef typename typdump::value_type::pol_t pol;
  typedef typename pol::monom_t mon; 
  typedef typename pol::coeff_t coeff;
  list<mon> current;
  //dans stockmon on a maintenant les monomes du quotient; 
  //on le multiplis par la variable p
  current=stockmon;
  for(typename list<mon>::iterator iter=current.begin();iter!=current.end();iter++)
    {
      *iter*=mon(p,1);
    }
  //maintenant on ecrit la matrice
  {
    int j=0;
    m=typmat(current.size(),current.size());
    for(typename list<mon>::iterator iter=current.begin()
	  ;iter!=current.end();iter++,j++)
      {
	if(!IsinB(*iter,b))
	{
	  pol tmp;
	  findcorresppol(*iter,dump,tmp);
	  mon tmpmon;
	  for(int i=0;i<tmp.size;i++)
	    {
	      serv.int2mon(i,tmpmon);
	      if(IsinB(tmpmon,b))
		m(indice(tmpmon,stockmon),j,tmp.nf[i]*(coeff)(-1));
	    }
	}
	else
	  {
	    m(indice(*iter,stockmon),j,iter->coeff());
	  }
      }
  }
  return;
}

__END_NAMESPACE_SYNAPS



