
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<>
void INIT_ELEM<pol<mon,Scl<MPF> > >(void *ptr, int size)
{
  typedef pol<mon,Scl<MPF> > pol;
  int nbelem=size/sizeof(pol),k=0;
  for(pol *i=(pol*)ptr;k<nbelem;i++,k++)
    mpf_init(((i->ind).coeff.rep()));
  }

template<>
void INIT_ELEM<Scl<MPF> >(void * ptr, int size)
{
  int nbelem=size/sizeof(Scl<MPF>),k=0;
  for(Scl<MPF> *i=(Scl<MPF> *)ptr;k<nbelem;i++,k++)
    mpf_init(i->rep())
      ;
}
template<>
void CLEAR_ELEM<Scl<MPF> >(void * ptr, int size)
{
  //cout<<"clear elem "<<endl;
  int nbelem=size/sizeof(Scl<MPF>),k=0;
  for(Scl<MPF> *i=(Scl<MPF>*)ptr;k<nbelem;i++,k++)
    mpf_clear(i->rep());
}
//template<>
//void CLEAR_ELEM<pol<mon,Scl<MPF> > >(void *ptr, int size)
//{
//  typedef pol<mon,Scl<MPF> > pol;
//  typedef pol::coeff_t coeff;
//  int nbelem=size/sizeof(pol),k=0;
//  for(pol *i=(pol*)ptr;k<nbelem;i++,k++) 
//    {
//      mpf_clear(((i->ind).coeff.rep()));
//      MAC_REV_FREE<coeff>(i->nf,i->size*sizeof(coeff));
//    }
//}


__END_NAMESPACE_SYNAPS

