#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS

namespace gmv
{
  stream::stream( const char * fname, bool binary  )
  {
    m_binary = binary;
    m_fd = fopen( fname, "wb" );
    assert(m_fd);
    for ( int i = 0; i < 4; i ++ ) m_lcolor[i] = 1.0;
    fprintf( m_fd, "LIST\n");
  };
  
  void  stream::line_color( float * color )
  {
    for ( int i = 0; i < 4; i ++ ) m_lcolor[i] = color[i];
  };
  void stream::flush() { fflush(m_fd); };
  stream::~stream() { fclose(m_fd); };

};
__END_NAMESPACE_SYNAPS
