#include <fstream>
#include <synaps/shape/curves/SISLBSplineCurve.h>
#include <synaps/shape/curves/MPDRationalCurve.h>
#include <synaps/shape/wrappers/WShapeFactory.h>



typedef type::gentlist< MPolDseRationalCurve<double,3>, SISLBSplineCurve >::T List;


int main( int argc, char ** argv )
{
  WShapeFactory< List > Factory;
  std::ifstream in(argv[1]);
  SISLBSplineCurve tmp;
  readGo(tmp,in);
  std::cout << tmp.length(1e-6) << std::endl;
  MPolDseRationalCurve<double,3> rc;
  rc.setEquations("1","t","t","t");
  std::cout << rc.length(1e-6) << std::endl;
  gmv::stream o("pcurve.out");
  //o << tmp;
  std::cout << tmp.iname() << std::endl;
  std::cout << rc.iname() << std::endl;
  std::cout << tmp.repname() << std::endl;

  //  IGLGood * gl = tmp.mesh();

  return 0;
}


;

