#include <iostream>
#include <synaps/arithm/gmp.h>
#include "synaps/upol.h"
#include "synaps/usolve/bezier/IslBzBdgSturm.h"

int main()
{
  using std::cout;
  using std::cin;
  using std::endl;

  UPolDse<ZZ> P("2*x0^7+3*x0^6+2*x0^5+1*x0^4-1*x0^3-2*x0^2-3*x0+1");
  cout <<"Testing: "<<P<<endl;
  IslBzBdgSturm<double> mth;
  cout <<solve(P,mth,double(-1),double(1))<<endl;
  cout <<solve(P,mth)<<endl;
}

